#ifndef _MY_LAYER_STACK
#define _MY_LAYER_STACK

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <cv.h>
#include <highgui.h>

class myLayerStack{

private:

	int mW;
	int mH;
	int mCH;
	int mFrame;
	double mBright;
	double *mData;
	int mLayerNum;
	int *mZ;
	int getArrayNum(int x, int y, int ch, int frame, int layer);

public:

	myLayerStack(void);
	~myLayerStack();

	void init(int W, int H, int CH, int Frame, double Bright, int LayerNum, int *Z);
	int get_W_size(void);
	int get_H_size(void);
	int get_CH_size(void);
	int get_Frame_size(void);
	double get_Bright(void);
	int get_LayerNum(void);
	int get_LayerZ(int layer);
	int get_DataSize(void);
	double getValue(int x, int y, int ch, int frame, int layer);
	double *getDataPointer(void);
	void setValue(int x, int y, int ch, int frame, int layer, double value);
	void setLayer(int frame, int layer, IplImage *img);
	void setRandom(void);
	IplImage *getLayerImage(int frame, int layer);
	void saveLayerStack(char *filename);
	myLayerStack *cloneLayerStack(void);
	double getL2norm(int ch, int layer, int frame);
	void showLayerStack(double Scale);
};

#endif
