#ifndef _MY_LIGHT_FIELD
#define _MY_LIGHT_FIELD

#include <stdio.h>
#include <math.h>
#include <cv.h>
#include <highgui.h>
#include "myLayerStack.h"
#include "myTransformCoordinate.h"

class myLightField{

private:

	int mW;
	int mH;
	int mT;
	int mP;
	int mCH;
	double *mData;
	int getArrayNum(int x, int y, int theta, int phi, int ch);

public:

	myLightField(void);
	~myLightField();

	void init(int W, int H, int T, int P, int CH);
	int get_W_size(void);
	int get_H_size(void);
	int get_T_size(void);
	int get_P_size(void);
	int get_CH_size(void);
	int get_DataSize(void);

	double getValue(int x, int y, int theta, int phi, int ch);
	double getValueDoubleXY(double x, double y, int theta, int phi, int ch);
	void setValue(int x, int y, int theta, int phi, int ch, double value);
	double *getDataPointer(void);
	void loadMultiViewImages(int T, int P, const char *ImageFileName);
	IplImage *getViewImage(int T, int P);
	void setViewImage(int T, int P, IplImage *img);
	void saveLightField_asImages(char *filename);
	double *getFocusImageDouble(double z);
	myLightField *cloneLightField(void);
	void setRandom(void);
	double getL2norm(int ch);
	void simulateLightFieldFromLayerStack(myLayerStack *LS);

};

#endif
